package com.nestoleh.textprotector.formatter.shield

import kotlin.math.absoluteValue

object EmojiShield : Shield {
    private val emojis: List<String> = listOf(
        "\uD83D\uDE00",
        "\uD83D\uDE03",
        "\uD83D\uDE04",
        "\uD83D\uDE01",
        "\uD83D\uDE06",
        "\uD83D\uDE05",
        "\uD83D\uDE02",
        "\uD83E\uDD23",
        "\uD83E\uDD72",
        "\uD83D\uDE0A",
        "\uD83D\uDE07",
        "\uD83D\uDE42",
        "\uD83D\uDE43",
        "\uD83D\uDE09",
        "\uD83D\uDE0C",
        "\uD83D\uDE0D",
        "\uD83E\uDD70",
        "\uD83D\uDE18",
        "\uD83D\uDE17",
        "\uD83D\uDE19",
        "\uD83D\uDE1A",
        "\uD83D\uDE0B",
        "\uD83D\uDE1B",
        "\uD83D\uDE1D",
        "\uD83D\uDE1C",
        "\uD83E\uDD2A",
        "\uD83E\uDD28",
        "\uD83E\uDDD0",
        "\uD83E\uDD13",
        "\uD83D\uDE0E",
        "\uD83E\uDD78",
        "\uD83E\uDD29",
        "\uD83E\uDD73",
        "\uD83D\uDE0F",
        "\uD83D\uDE12",
        "\uD83D\uDE1E",
        "\uD83D\uDE14",
        "\uD83D\uDE1F",
        "\uD83D\uDE15",
        "\uD83D\uDE41",
        "\uD83D\uDE23",
        "\uD83D\uDE16",
        "\uD83D\uDE2B",
        "\uD83D\uDE29",
        "\uD83E\uDD7A",
        "\uD83D\uDE22",
        "\uD83D\uDE2D",
        "\uD83D\uDE24",
        "\uD83D\uDE20",
        "\uD83D\uDE21",
        "\uD83E\uDD2C",
        "\uD83E\uDD2F",
        "\uD83D\uDE33",
        "\uD83E\uDD75",
        "\uD83E\uDD76",
        "\uD83D\uDE31",
        "\uD83D\uDE28",
        "\uD83D\uDE30",
        "\uD83D\uDE25",
        "\uD83D\uDE13",
        "\uD83E\uDD17",
        "\uD83E\uDD14",
        "\uD83E\uDD2D",
        "\uD83E\uDD2B",
        "\uD83E\uDD25",
        "\uD83D\uDE36",
        "\uD83D\uDE10",
        "\uD83D\uDE11",
        "\uD83D\uDE2C",
        "\uD83D\uDE44",
        "\uD83D\uDE2F",
        "\uD83D\uDE26",
        "\uD83D\uDE27",
        "\uD83D\uDE2E",
        "\uD83D\uDE32",
        "\uD83E\uDD71",
        "\uD83D\uDE34",
        "\uD83E\uDD24",
        "\uD83D\uDE2A",
        "\uD83D\uDE35",
        "\uD83E\uDD10",
        "\uD83E\uDD74",
        "\uD83E\uDD22",
        "\uD83E\uDD2E",
        "\uD83E\uDD27",
        "\uD83D\uDE37",
        "\uD83E\uDD12",
        "\uD83E\uDD15",
        "\uD83E\uDD11",
        "\uD83E\uDD20",
        "\uD83D\uDE08",
        "\uD83D\uDC7F",
        "\uD83D\uDC79",
        "\uD83D\uDC7A",
        "\uD83E\uDD21",
        "\uD83D\uDCA9",
        "\uD83D\uDC7B",
        "\uD83D\uDC80",
        "\uD83D\uDC7D",
        "\uD83D\uDC7E",
        "\uD83E\uDD16",
        "\uD83C\uDF83",
        "\uD83D\uDE3A",
        "\uD83D\uDE38",
        "\uD83D\uDE39",
        "\uD83D\uDE3B",
        "\uD83D\uDE3C",
        "\uD83D\uDE3D",
        "\uD83D\uDE40",
        "\uD83D\uDE3F",
        "\uD83D\uDE3E"
    )

    override fun shieldByIndex(index: Int): String {
        val recountedIndex = recountIndex(index)
        return emojis[recountedIndex]
    }

    private fun recountIndex(index: Int): Int {
        return index.absoluteValue % emojis.size
    }
}